// FileManager.cpp: FileManager NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "RangeImageViewer.h"
#include "FileManager.h"
#include "RangeImage.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

FileManager::FileManager()
{
	image = NULL;
}

FileManager::~FileManager()
{

}

void FileManager::setRangeImage(RangeImage *image)
{
	this->image = image;
}

void FileManager::readFile(CString file_name)
{
	FILE* file = fopen(file_name,"r");

	int sizeX;
	fscanf(file, "%d", &sizeX);
	int sizeY;
	fscanf(file, "%d", &sizeY);
	int max;
	fscanf(file, "%d", &max);

	image->setSize(sizeX, sizeY);

	float **I = image->I;

	for(int i=0; i<sizeY; i++)
		for(int j=0; j<sizeX; j++){
			float data;
			fscanf(file, "%f", &data);
			I[i][j] = data*255.0f/(float)max;;
		}

	fclose(file);
}

void FileManager::readFileByYagou(CString file_name)
{
	int i,j;
	int k, kk;
	char buffer[10];
	FILE *ipst;  /* InPut STream */

	ipst = fopen(file_name, "r");
	if (!ipst){
		fprintf(stderr, "Can't open the pgm file %s\n", buffer);
		exit(0);
	}

	fscanf(ipst,"%s",buffer);

	/* skip comment lines if exists */
	k = getc(ipst);
	while ((kk=getc(ipst)) == '#') {
		i = -1;
		fprintf(stderr,"\nfile = ");
		do {
			i++;
			k = getc(ipst);
        }while (k != '\n');
    }
	if (kk != '#') ungetc(kk,ipst);
  
	int sizeX, sizeY;
	fscanf(ipst,"%d",&sizeX);
	fscanf(ipst,"%d",&sizeY);

	/* 摜̎,  */
	image->setSize(sizeX, sizeY);

	int max;
	fscanf(ipst,"%d",&max);

	/* pgmt@C̃XybN\ */
	//fprintf(stderr, "Magic number: %s", buffer);
	//fprintf(stderr, "\nResolution: %d x %d", img->width, img->height);
	//fprintf(stderr, "\nThe number of pixels: %d", img->pixels);
    
	/* Pxl̓ǂݍ */
	if (buffer[1] == '5'){
		/* P5t@CioCif[^j̓ǂݍ */
		unsigned char* tmp = new unsigned char[sizeY*sizeX];
		fread(tmp, sizeof(unsigned char), sizeY*sizeX, ipst);

		for(i=0; i<sizeY; i++){
			for(j=0; j<sizeX; j++){
				image->I[i][j] = 255.0f*(float)tmp[i*sizeX+j]/(float)max;
			}
		}
		delete[] tmp;

		//for (i = 0; i < img->pixels; i++)
			//fread(img->I, sizeof(pixel), img->pixels, ipst);
    }
	else {
		/* P2t@CiAXL[f[^j̓ǂݍ */
		for(int i=0; i<sizeY; i++)
			for(int j=0; j<sizeX; j++){
				int data;
				fscanf(ipst, "%d", &data);
				image->I[i][j] = (float)data*255.0f/(float)max;;
			}
		//for (i = 0; i < img->pixels; i++){
			//fscanf(ipst, "%d", &integer_value);
			//img->I[i] = integer_value;
        //}
    }
	fclose(ipst);
	//free(ipst);
}

void FileManager::writeDataFile(CString file_name)
{
	FILE* file = fopen(file_name,"w");

	fprintf(file, "%d %d\n", image->sizeX, image->sizeY);
	fprintf(file, "255\n");
	for(int i=0; i<image->sizeY; i++){
		for(int j=0; j<image->sizeX; j++){
			fprintf(file, "%f ", image->I[i][j]);
		}
	}
	fclose(file);
}
