// RangeImageViewerView.cpp : CRangeImageViewerView NX̓̒`s܂B
//

#include "stdafx.h"
#include "RangeImageViewer.h"

#include "RangeImageViewerDoc.h"
#include "RangeImageViewerView.h"

#include "RangeImage.h"

#include <gl\gl.h>
#include <gl\glu.h>
#include <math.h>

#define PI 3.14159265

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRangeImageViewerView

IMPLEMENT_DYNCREATE(CRangeImageViewerView, CView)

BEGIN_MESSAGE_MAP(CRangeImageViewerView, CView)
	//{{AFX_MSG_MAP(CRangeImageViewerView)
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_WM_CREATE()
	ON_WM_RBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_KEYDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_MOUSEWHEEL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRangeImageViewerView NX̍\z/

CRangeImageViewerView::CRangeImageViewerView()
{
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB
	isPerspective = true;

	eye[0] = 26;
	eye[1] = -48;
	eye[2] = 40;

	center[0] = 0.0;
	center[1] = 0.0;
	center[2] = 0.0;

	Rx = 0;
	Ry = 0;
	Rz = 0;

	vx[0] = 0;
	vx[1] = 0;
	vx[2] = 1;

	vy[0] = -(float)(eye[1]/sqrt(eye[0]*eye[0]+eye[1]*eye[1]));
	vy[1] = (float)(eye[0]/sqrt(eye[0]*eye[0]+eye[1]*eye[1]));
	vy[2] = 0;

	view_angle = 10.5;

	//view_angle = 100;

	isLPressed = FALSE;
	isRPressed = FALSE;

	shift_x = 0;
	shift_y = 0;
	shift_z = 0;
}

CRangeImageViewerView::~CRangeImageViewerView()
{
}

BOOL CRangeImageViewerView::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.style |= WS_CLIPCHILDREN | WS_CLIPSIBLINGS;
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CRangeImageViewerView NX̕`

void CRangeImageViewerView::OnDraw(CDC* pDC)
{
	CRangeImageViewerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
	wglMakeCurrent(pDC->m_hDC, m_hRC);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	//TRACE("%f, %f\n", Ry, Rz);
	//TRACE("%f\n", view_angle);

	glPushMatrix();
	glTranslatef(shift_x,shift_y,shift_z);
	//glTranslatef(0,0,10);
	glRotatef(Ry,vy[0],vy[1],vy[2]);
	glRotatef(Rz,vx[0],vx[1],vx[2]);
	//glTranslatef(0,0,-10);
	//glCallList(1);
	pDoc->drawImage();
	glPopMatrix();

	glFlush();
	SwapBuffers(wglGetCurrentDC());
	wglMakeCurrent(pDC->m_hDC, NULL);
}

/////////////////////////////////////////////////////////////////////////////
// CRangeImageViewerView NX̐ff

#ifdef _DEBUG
void CRangeImageViewerView::AssertValid() const
{
	CView::AssertValid();
}

void CRangeImageViewerView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CRangeImageViewerDoc* CRangeImageViewerView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CRangeImageViewerDoc)));
	return (CRangeImageViewerDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRangeImageViewerView NX̃bZ[W nh

void CRangeImageViewerView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	int i;
	GLdouble up[3];
	GLdouble vector[3];
	GLdouble norm;

	CClientDC clientDC(this);

	wglMakeCurrent(clientDC.m_hDC, m_hRC);

	glViewport(0, 0, cx, cy);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	//gluPerspective(3, (GLfloat)cx/(GLfloat)cy, 10.0, 4000.0);
	if(isPerspective)
		gluPerspective(view_angle, (GLfloat)cx/(GLfloat)cy, 10.0, 4000.0);
	else
		glOrtho(-10,10,-10.0*cy/cx,10.0*cy/cx,10,4000);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	for(i=0; i<3; i++)
		vector[i] = center[i] - eye[i];

	up[0] =  vector[0] * vector[2];
	up[1] =  vector[1] * vector[2];
	up[2] =  vector[0] * vector[0] + vector[1] * vector[1];

	norm = up[0] * up[0] + up[1] * up[1] + up[2] * up[2];
	norm = sqrt(norm);
	for(i=0; i<3; i++)
		up[i] = up[i] / norm;
	
	gluLookAt(eye[0], eye[1], eye[2], center[0], center[1], center[2],
		up[0], up[1], up[2]);

	wglMakeCurrent(clientDC.m_hDC, NULL);
}

void CRangeImageViewerView::OnDestroy() 
{
	CView::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	wglDeleteContext(m_hRC);
}

int CRangeImageViewerView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: ̈ʒuɌŗL̍쐬pR[hǉĂ
	PIXELFORMATDESCRIPTOR pfd =
	{
		sizeof(PIXELFORMATDESCRIPTOR),
		1,
		PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER,
		PFD_TYPE_RGBA,
		16,
		0,0,0,0,0,0,
		0,0,0,0,0,0,0,
		32,
		0,0,
		PFD_MAIN_PLANE,
		0,
		0,0,0
	};

	CClientDC  clientDC(this);

	int pixelFormat = ChoosePixelFormat(clientDC.m_hDC, &pfd);
	if(!SetPixelFormat(clientDC.m_hDC, pixelFormat, &pfd))
		return -1;

	m_hRC = wglCreateContext(clientDC.m_hDC);

	wglMakeCurrent(clientDC.m_hDC,m_hRC);
	initGL();
	wglMakeCurrent(clientDC.m_hDC,NULL);
	return 0;
}

void CRangeImageViewerView::OnRButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	isRPressed = false;

	CView::OnRButtonUp(nFlags, point);
}

void CRangeImageViewerView::initGL()
{
	GLfloat light_position1[4] = {-52, -16, -50, 0};
	GLfloat light_position2[4] = {-26, -48, -50, 0};
	GLfloat light_position3[4] = { 16, -52, -50, 0};

	GLfloat direction1[3] = {52,16,50};
	GLfloat direction2[3] = {26,48,50};
	GLfloat direction3[3] = {-16,52,50};

	GLfloat light_position4[4] = {52, 16, 50, 0};
	GLfloat light_position5[4] = {26, 48, 50, 0};
	GLfloat light_position6[4] = {-16, 52, 50, 0};

	GLfloat direction4[3] = {-52,-16,-50};
	GLfloat direction5[3] = {-26,-48,-50};
	GLfloat direction6[3] = {16,-52,-50};

	GLfloat color1[4] = {1,0,0,1};
	GLfloat color2[4] = {0,1,0,1};
	GLfloat color3[4] = {0,0,1,1};

	GLfloat color4[4] = {1,0,0,1};
	GLfloat color5[4] = {0,1,0,1};
	GLfloat color6[4] = {0,0,1,1};

	GLfloat ambient[4] = {0.3f,0.3f,0.3f,1.0f};

	GLfloat material_color[4] = {1,1,1,0.5};
	GLfloat material_specular[4] = {0.5,0.5,0.5,0.5};
	GLfloat material_ambient[4] = {0.0,0.0,0.0,0.0};

	glClearColor(1,1,1,0);
	//glClearColor(0.7,0.7,0.7,0);

	glLightfv(GL_LIGHT0, GL_POSITION, light_position1);
	glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION, direction1);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, color1);
	glLightfv(GL_LIGHT0, GL_SPECULAR, color1);

	glLightfv(GL_LIGHT1, GL_POSITION, light_position2);
	glLightfv(GL_LIGHT1, GL_SPOT_DIRECTION, direction2);
	glLightfv(GL_LIGHT1, GL_DIFFUSE, color2);
	glLightfv(GL_LIGHT1, GL_SPECULAR, color2);

	glLightfv(GL_LIGHT2, GL_POSITION, light_position3);
	glLightfv(GL_LIGHT2, GL_SPOT_DIRECTION, direction3);
	glLightfv(GL_LIGHT2, GL_DIFFUSE, color3);
	glLightfv(GL_LIGHT2, GL_SPECULAR, color3);

	glLightfv(GL_LIGHT3, GL_POSITION, light_position4);
	glLightfv(GL_LIGHT3, GL_SPOT_DIRECTION, direction4);
	glLightfv(GL_LIGHT3, GL_DIFFUSE, color4);
	glLightfv(GL_LIGHT3, GL_SPECULAR, color4);

	glLightfv(GL_LIGHT4, GL_POSITION, light_position5);
	glLightfv(GL_LIGHT4, GL_SPOT_DIRECTION, direction5);
	glLightfv(GL_LIGHT4, GL_DIFFUSE, color5);
	glLightfv(GL_LIGHT4, GL_SPECULAR, color5);

	glLightfv(GL_LIGHT5, GL_POSITION, light_position6);
	glLightfv(GL_LIGHT5, GL_SPOT_DIRECTION, direction6);
	glLightfv(GL_LIGHT5, GL_DIFFUSE, color6);
	glLightfv(GL_LIGHT5, GL_SPECULAR, color6);

	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, ambient);

	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, material_specular);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, material_color);
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, material_ambient);
	glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, 128);

	glEnable(GL_LIGHTING);

	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHT1);
	glEnable(GL_LIGHT2);	

	glEnable(GL_LIGHT3);
	glEnable(GL_LIGHT4);
	glEnable(GL_LIGHT5);

	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LESS);
	//glEnable(GL_BLEND);
	//glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	//glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); 
}

void CRangeImageViewerView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	isRPressed = true;
	px = point.x;
	py = point.y;

	CView::OnRButtonDown(nFlags, point);
}

void CRangeImageViewerView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	isLPressed = true;
	px = point.x;
	py = point.y;

	CView::OnLButtonDown(nFlags, point);
}

void CRangeImageViewerView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	isLPressed = false;

	CView::OnLButtonUp(nFlags, point);
}

void CRangeImageViewerView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	switch(nChar){
	case VK_UP:
		shift_z += 1;
		break;
	case VK_DOWN:
		shift_z -= 1;
		break;
	case VK_RIGHT:
		shift_x += 1;
		break;
	case VK_LEFT:
		shift_x -= 1;
		break;
	}
	CClientDC* dc = new CClientDC(this); 
	OnDraw(dc);
	delete dc;

	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CRangeImageViewerView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	if(isLPressed){
		int nx = point.x;
		int ny = point.y;
		
		Rz += (nx - px)/3;
		Ry += (ny - py)/3;
		px = nx;
		py = ny;
		CClientDC* dc = new CClientDC(this); 
		OnDraw(dc);
		delete dc;
	}
	else if(isRPressed){
		int nx = point.x;
		int ny = point.y;

		view_angle += (ny - py)/20.0f;
		px = nx;
		py = ny;
		CClientDC* dc = new CClientDC(this);

		RECT* rect = new RECT;
		GetClientRect(rect);
		OnSize(SIZE_RESTORED, rect->right, rect->bottom);
		delete rect;
		OnDraw(dc);
		delete dc;
	}
	
	CView::OnMouseMove(nFlags, point);
}

BOOL CRangeImageViewerView::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	
	return CView::OnMouseWheel(nFlags, zDelta, pt);
}

void CRangeImageViewerView::drawShadedImage(RangeImage *image)
{
	glShadeModel(GL_SMOOTH);

	//setViewMode(true, 0);

	int sizeX = image->sizeX;
	int sizeY = image->sizeY;
	float (**normal)[3] = image->normal;
	float **I = image->I;

	float ds = 10.0f/max(sizeX, sizeY);
	float dh = 0.01f;
	float tx = -0.5f*ds*sizeX;
	float ty = -0.5f*ds*sizeY;

	for(int i=0; i<sizeY-1; i++){
		for(int j=0; j<sizeX-1; j++){
			glBegin(GL_POLYGON);
			float n[3];

			n[0] = normal[i][j][0];
			n[1] = normal[i][j][1];
			n[2] = normal[i][j][2]*ds/dh;
			float len = sqrt(n[0]*n[0] + n[1]*n[1] + n[2]*n[2]);
			n[0] /= len;
			n[1] /= len;
			n[2] /= len;
			glNormal3fv(n);
			glVertex3f(ds*j+tx, ds*i+ty, dh*I[i][j]);


			n[0] = normal[i][j+1][0];
			n[1] = normal[i][j+1][1];
			n[2] = normal[i][j+1][2]*ds/dh;
			len = sqrt(n[0]*n[0] + n[1]*n[1] + n[2]*n[2]);
			n[0] /= len;
			n[1] /= len;
			n[2] /= len;
			glNormal3fv(n);
			glVertex3f(ds*(j+1)+tx, ds*i+ty, dh*I[i][j+1]);


			n[0] = normal[i+1][j+1][0];
			n[1] = normal[i+1][j+1][1];
			n[2] = normal[i+1][j+1][2]*ds/dh;
			len = sqrt(n[0]*n[0] + n[1]*n[1] + n[2]*n[2]);
			n[0] /= len;
			n[1] /= len;
			n[2] /= len;
			glNormal3fv(n);
			glVertex3f(ds*(j+1)+tx, ds*(i+1)+ty, dh*I[i+1][j+1]);

		
			n[0] = normal[i+1][j][0];
			n[1] = normal[i+1][j][1];
			n[2] = normal[i+1][j][2]*ds/dh;
			len = sqrt(n[0]*n[0] + n[1]*n[1] + n[2]*n[2]);
			n[0] /= len;
			n[1] /= len;
			n[2] /= len;
			glNormal3fv(n);
			glVertex3f(ds*j+tx, ds*(i+1)+ty, dh*I[i+1][j]);

			glEnd();
		}
	}
}

void CRangeImageViewerView::flatShading(RangeImage *image)
{
	glShadeModel(GL_FLAT);

	int sizeX = image->sizeX;
	int sizeY = image->sizeY;
	float (**normal_f)[3] = image->normal_f;
	float **I = image->I;

	float ds = 10.0f/max(sizeX, sizeY);
	float dh = 0.01f;
	float tx = -0.5f*ds*sizeX;
	float ty = -0.5f*ds*sizeY;

	for(int i=0; i<sizeY-1; i++){
		for(int j=0; j<sizeX-1; j++){
			float v[4][3];
			v[0][0] = ds*j+tx;
			v[0][1] = ds*i+ty;
			v[0][2] = dh*I[i][j];

			v[1][0] = ds*(j+1)+tx;
			v[1][1] = ds*i+ty;
			v[1][2] = dh*I[i][j+1];

			v[2][0] = ds*(j+1)+tx;
			v[2][1] = ds*(i+1)+ty;
			v[2][2] = dh*I[i+1][j+1];

			v[3][0] = ds*j+tx;
			v[3][1] = ds*(i+1)+ty;
			v[3][2] = dh*I[i+1][j];

			float n[3];
			/*
			n[0] = (v[1][1]-v[0][1])*(v[1][2]+v[0][2]) + (v[2][1]-v[1][1])*(v[2][2]+v[1][2])
					+ (v[3][1]-v[2][1])*(v[3][2]+v[2][2]) + (v[0][1]-v[3][1])*(v[0][2]+v[3][2]);
			n[1] = (v[1][2]-v[0][2])*(v[1][0]+v[0][0]) + (v[2][2]-v[1][2])*(v[2][0]+v[1][0])
					+ (v[3][2]-v[2][2])*(v[3][0]+v[2][0]) + (v[0][2]-v[3][2])*(v[0][0]+v[3][0]);
			n[2] = (v[1][0]-v[0][0])*(v[1][1]+v[0][1]) + (v[2][0]-v[1][0])*(v[2][1]+v[1][1])
					+ (v[3][0]-v[2][0])*(v[3][1]+v[2][1]) + (v[0][0]-v[3][0])*(v[0][1]+v[3][1]);
					*/
			n[0] = normal_f[i][j][0];
			n[1] = normal_f[i][j][1];
			n[2] = normal_f[i][j][2]*ds/dh;
			float len = sqrt(n[0]*n[0] + n[1]*n[1] + n[2]*n[2]);
			n[0] /= len;
			n[1] /= len;
			n[2] /= len;

			glBegin(GL_POLYGON);
				glNormal3fv(n);
				glVertex3fv(v[0]); 
				glVertex3fv(v[1]);
				glVertex3fv(v[2]);
				glVertex3fv(v[3]);
			glEnd();
		}
	}
}

void CRangeImageViewerView::drawImageWithRidge(RangeImage *image)
{
	//setViewMode(false, 1);

	glDeleteLists(1,1);
	glNewList(1, GL_COMPILE);
	glShadeModel(GL_FLAT);

	int sizeX = image->sizeX;
	int sizeY = image->sizeY;
	float (**normal_f)[3] = image->normal_f;
	float **I = image->I;

	float ds = 10.0f/max(sizeX, sizeY);
	float dh = 0.01f;
	float tx = -0.5f*ds*sizeX;
	float ty = -0.5f*ds*sizeY;

	glDisable(GL_LIGHTING);

	float max = 260*dh;
	for(int i=0; i<sizeY; i++){
		for(int j=0; j<sizeX; j++){
			//if(I[i][j] <= 0 || I[i][j] >= 255)
				//continue;
			if(image->isEdge[i][j]){
				float v[4][3];
				v[0][0] = ds*j+tx - 0.5*ds;
				v[0][1] = ds*i+ty - 0.5*ds;
				v[0][2] = max;

				v[1][0] = ds*j+tx + 0.5*ds;
				v[1][1] = ds*i+ty - 0.5*ds;
				v[1][2] = max;

				v[2][0] = ds*j+tx + 0.5*ds;
				v[2][1] = ds*i+ty + 0.5*ds;
				v[2][2] = max;

				v[3][0] = ds*j+tx - 0.5*ds;
				v[3][1] = ds*i+ty + 0.5*ds;
				v[3][2] = max;

				glColor3f(0,0,0);
				glBegin(GL_POLYGON);
					glVertex3fv(v[0]); 
					glVertex3fv(v[1]);
					glVertex3fv(v[2]);
					glVertex3fv(v[3]);
				glEnd();
			}
			else if(image->isRidge[i][j]){
				float v[4][3];
				v[0][0] = ds*j+tx - 0.5*ds;
				v[0][1] = ds*i+ty - 0.5*ds;
				v[0][2] = max;

				v[1][0] = ds*j+tx + 0.5*ds;
				v[1][1] = ds*i+ty - 0.5*ds;
				v[1][2] = max;

				v[2][0] = ds*j+tx + 0.5*ds;
				v[2][1] = ds*i+ty + 0.5*ds;
				v[2][2] = max;

				v[3][0] = ds*j+tx - 0.5*ds;
				v[3][1] = ds*i+ty + 0.5*ds;
				v[3][2] = max;

				glColor3f(1,0,0);
				glBegin(GL_POLYGON);
					glVertex3fv(v[0]); 
					glVertex3fv(v[1]);
					glVertex3fv(v[2]);
					glVertex3fv(v[3]);
				glEnd();
			}
			else if(image->isRavine[i][j]){
				float v[4][3];
				v[0][0] = ds*j+tx - 0.5*ds;
				v[0][1] = ds*i+ty - 0.5*ds;
				v[0][2] = max;

				v[1][0] = ds*j+tx + 0.5*ds;
				v[1][1] = ds*i+ty - 0.5*ds;
				v[1][2] = max;

				v[2][0] = ds*j+tx + 0.5*ds;
				v[2][1] = ds*i+ty + 0.5*ds;
				v[2][2] = max;

				v[3][0] = ds*j+tx - 0.5*ds;
				v[3][1] = ds*i+ty + 0.5*ds;
				v[3][2] = max;

				glColor3f(0,0,1);
				glBegin(GL_POLYGON);
					glVertex3fv(v[0]); 
					glVertex3fv(v[1]);
					glVertex3fv(v[2]);
					glVertex3fv(v[3]);
				glEnd();
			}
		}
	}

	glEnable(GL_LIGHTING);
/*
	for(i=0; i<sizeY-1; i++){
		for(int j=0; j<sizeX-1; j++){
			float v[4][3];
			v[0][0] = ds*j+tx;
			v[0][1] = ds*i+ty;
			v[0][2] = dh*I[i][j];

			v[1][0] = ds*(j+1)+tx;
			v[1][1] = ds*i+ty;
			v[1][2] = dh*I[i][j+1];

			v[2][0] = ds*(j+1)+tx;
			v[2][1] = ds*(i+1)+ty;
			v[2][2] = dh*I[i+1][j+1];

			v[3][0] = ds*j+tx;
			v[3][1] = ds*(i+1)+ty;
			v[3][2] = dh*I[i+1][j];

			float n[3];
			n[0] = normal_f[i][j][0];
			n[1] = normal_f[i][j][1];
			n[2] = normal_f[i][j][2]*ds/dh;
			float len = sqrt(n[0]*n[0] + n[1]*n[1] + n[2]*n[2]);
			n[0] /= len;
			n[1] /= len;
			n[2] /= len;

			glBegin(GL_POLYGON);
				glNormal3fv(n);
				glVertex3fv(v[0]); 
				glVertex3fv(v[1]);
				glVertex3fv(v[2]);
				glVertex3fv(v[3]);
			glEnd();
		}
	}*/
}

void CRangeImageViewerView::setViewMode(bool isPerspective, int mode)
{
	GLfloat light_position1[4] = {-52, -16, -50, 0};
	GLfloat light_position2[4] = {-26, -48, -50, 0};
	GLfloat light_position3[4] = { 16, -52, -50, 0};

	GLfloat direction1[3] = {52,16,50};
	GLfloat direction2[3] = {26,48,50};
	GLfloat direction3[3] = {-16,52,50};

	GLfloat light_position4[4] = {52, 16, 50, 0};
	GLfloat light_position5[4] = {26, 48, 50, 0};
	GLfloat light_position6[4] = {-16, 52, 50, 0};

	GLfloat direction4[3] = {-52,-16,-50};
	GLfloat direction5[3] = {-26,-48,-50};
	GLfloat direction6[3] = {16,-52,-50};

	GLfloat color1[4] = {1,0,0,1};
	GLfloat color2[4] = {0,1,0,1};
	GLfloat color3[4] = {0,0,1,1};

	if(mode == 1){
		color1[0] = 0.5;
		color1[1] = 0.5;
		color1[2] = 0.5;

		color2[0] = 0.5;
		color2[1] = 0.5;
		color2[2] = 0.5;

		color3[0] = 0.5;
		color3[1] = 0.5;
		color3[2] = 0.5;
	}

	GLfloat color4[4] = {1,0,0,1};
	GLfloat color5[4] = {0,1,0,1};
	GLfloat color6[4] = {0,0,1,1};

	if(mode == 1){
		color4[0] = 0.5;
		color4[1] = 0.5;
		color4[2] = 0.5;

		color5[0] = 0.5;
		color5[1] = 0.5;
		color5[2] = 0.5;

		color6[0] = 0.5;
		color6[1] = 0.5;
		color6[2] = 0.5;
	}

	GLfloat ambient[4] = {0.3f,0.3f,0.3f,1.0f};

	GLfloat material_color[4] = {1,1,1,0.5};
	GLfloat material_specular[4] = {0.5,0.5,0.5,0.5};
	GLfloat material_ambient[4] = {0.0,0.0,0.0,0.0};

	glClearColor(1,1,1,0);
	//glClearColor(0.7,0.7,0.7,0);

	glLightfv(GL_LIGHT0, GL_POSITION, light_position1);
	glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION, direction1);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, color1);
	glLightfv(GL_LIGHT0, GL_SPECULAR, color1);

	glLightfv(GL_LIGHT1, GL_POSITION, light_position2);
	glLightfv(GL_LIGHT1, GL_SPOT_DIRECTION, direction2);
	glLightfv(GL_LIGHT1, GL_DIFFUSE, color2);
	glLightfv(GL_LIGHT1, GL_SPECULAR, color2);

	glLightfv(GL_LIGHT2, GL_POSITION, light_position3);
	glLightfv(GL_LIGHT2, GL_SPOT_DIRECTION, direction3);
	glLightfv(GL_LIGHT2, GL_DIFFUSE, color3);
	glLightfv(GL_LIGHT2, GL_SPECULAR, color3);

	glLightfv(GL_LIGHT3, GL_POSITION, light_position4);
	glLightfv(GL_LIGHT3, GL_SPOT_DIRECTION, direction4);
	glLightfv(GL_LIGHT3, GL_DIFFUSE, color4);
	glLightfv(GL_LIGHT3, GL_SPECULAR, color4);

	glLightfv(GL_LIGHT4, GL_POSITION, light_position5);
	glLightfv(GL_LIGHT4, GL_SPOT_DIRECTION, direction5);
	glLightfv(GL_LIGHT4, GL_DIFFUSE, color5);
	glLightfv(GL_LIGHT4, GL_SPECULAR, color5);

	glLightfv(GL_LIGHT5, GL_POSITION, light_position6);
	glLightfv(GL_LIGHT5, GL_SPOT_DIRECTION, direction6);
	glLightfv(GL_LIGHT5, GL_DIFFUSE, color6);
	glLightfv(GL_LIGHT5, GL_SPECULAR, color6);

	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, ambient);

	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, material_specular);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, material_color);
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, material_ambient);
	glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, 128);

	glEnable(GL_LIGHTING);

	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHT1);
	glEnable(GL_LIGHT2);	

	glEnable(GL_LIGHT3);
	glEnable(GL_LIGHT4);
	glEnable(GL_LIGHT5);

	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LESS);

	this->isPerspective = isPerspective;
}

void CRangeImageViewerView::wireFrame(RangeImage *image)
{
	glShadeModel(GL_FLAT);

	//setViewMode(true, 1);

	glDisable(GL_LIGHTING);

	int sizeX = image->sizeX;
	int sizeY = image->sizeY;
	float (**normal_f)[3] = image->normal_f;
	float **I = image->I;

	float ds = 10.0f/max(sizeX, sizeY);
	float dh = 0.01f;
	float tx = -0.5f*ds*sizeX;
	float ty = -0.5f*ds*sizeY;


	glColor3f(0,0,0);
	for(int i=0; i<sizeY-1; i++){
		for(int j=0; j<sizeX-1; j++){
			float v[4][3];
			v[0][0] = ds*j+tx;
			v[0][1] = ds*i+ty;
			v[0][2] = dh*I[i][j];

			v[1][0] = ds*(j+1)+tx;
			v[1][1] = ds*i+ty;
			v[1][2] = dh*I[i][j+1];

			v[2][0] = ds*(j+1)+tx;
			v[2][1] = ds*(i+1)+ty;
			v[2][2] = dh*I[i+1][j+1];

			v[3][0] = ds*j+tx;
			v[3][1] = ds*(i+1)+ty;
			v[3][2] = dh*I[i+1][j];

			float n[3];
			n[0] = normal_f[i][j][0];
			n[1] = normal_f[i][j][1];
			n[2] = normal_f[i][j][2]*ds/dh;
			float len = sqrt(n[0]*n[0] + n[1]*n[1] + n[2]*n[2]);
			n[0] /= len;
			n[1] /= len;
			n[2] /= len;

			glBegin(GL_LINES);
				glVertex3fv(v[0]);
				glVertex3fv(v[1]);
			glEnd();
			glBegin(GL_LINES);
				glVertex3fv(v[1]);
				glVertex3fv(v[2]);
			glEnd();

			/*
			glBegin(GL_POLYGON);
				glNormal3fv(n);
				glVertex3fv(v[0]); 
				glVertex3fv(v[1]);
				glVertex3fv(v[2]);
				glVertex3fv(v[3]);
			glEnd();*/
		}
	}

	glColor3f(1,1,1);
	//glPolygonMode(GL_FRONT, GL_LINE);

	for(i=0; i<sizeY-1; i++){
		for(int j=0; j<sizeX-1; j++){
			float v[4][3];
			v[0][0] = ds*j+tx;
			v[0][1] = ds*i+ty;
			v[0][2] = dh*I[i][j] - 0.01;

			v[1][0] = ds*(j+1)+tx;
			v[1][1] = ds*i+ty;
			v[1][2] = dh*I[i][j+1] - 0.01;

			v[2][0] = ds*(j+1)+tx;
			v[2][1] = ds*(i+1)+ty;
			v[2][2] = dh*I[i+1][j+1] - 0.01;

			v[3][0] = ds*j+tx;
			v[3][1] = ds*(i+1)+ty;
			v[3][2] = dh*I[i+1][j] - 0.01;

			float n[3];
			n[0] = normal_f[i][j][0];
			n[1] = normal_f[i][j][1];
			n[2] = normal_f[i][j][2]*ds/dh;
			float len = sqrt(n[0]*n[0] + n[1]*n[1] + n[2]*n[2]);
			n[0] /= len;
			n[1] /= len;
			n[2] /= len;

			glBegin(GL_POLYGON);
				//glNormal3fv(n);
				glVertex3fv(v[0]); 
				glVertex3fv(v[1]);
				glVertex3fv(v[2]);
				glVertex3fv(v[3]);
			glEnd();
		}
	}
	glEnable(GL_LIGHTING);
}

void CRangeImageViewerView::drawImage(RangeImage *image)
{
	glShadeModel(GL_FLAT);

	//setViewMode(true, 1);

	glDisable(GL_LIGHTING);

	int sizeX = image->sizeX;
	int sizeY = image->sizeY;

	float ds = 10.0f/max(sizeX, sizeY);
	float dh = 0.01f;
	float tx = -0.5f*ds*sizeX;
	float ty = -0.5f*ds*sizeY;

	glDisable(GL_LIGHTING);

	float max = 260*dh;
	for(int i=0; i<sizeY; i++){
		for(int j=0; j<sizeX; j++){
			float v[4][3];
			v[0][0] = ds*j+tx - 0.5*ds;
			v[0][1] = ds*i+ty - 0.5*ds;
			v[0][2] = max;

			v[1][0] = ds*j+tx + 0.5*ds;
			v[1][1] = ds*i+ty - 0.5*ds;
			v[1][2] = max;

			v[2][0] = ds*j+tx + 0.5*ds;
			v[2][1] = ds*i+ty + 0.5*ds;
			v[2][2] = max;

			v[3][0] = ds*j+tx - 0.5*ds;
			v[3][1] = ds*i+ty + 0.5*ds;
			v[3][2] = max;

			float I = image->I[i][j]/255.0;
			glColor3f(I,I,I);
			glBegin(GL_POLYGON);
				glVertex3fv(v[0]); 
				glVertex3fv(v[1]);
				glVertex3fv(v[2]);
				glVertex3fv(v[3]);
			glEnd();
		}
	}
	glEnable(GL_LIGHTING);
}

void CRangeImageViewerView::changeView()
{
	CClientDC* dc = new CClientDC(this); 
	OnDraw(dc);
	delete dc;
}
